﻿import ast
import json
import requests

r = requests.get("https://intuot.crpt.ru:12011/v2/api-docs", verify=False)
src = r.text.replace('true', 'True').replace('false', 'False') #.replace("'", '"')
#data = json.loads(src)
data = ast.literal_eval(src)

with open("src.json", "wt") as f:
    f.write(json.dumps(data))

res = {}

def default_value(_type):
    if _type == 'integer' or _type == 'float' or _type == 'number':
        return 0
    elif _type == 'string' or _type == 'file':
        return ''
    elif _type == 'boolean':
        return False
    elif _type == 'array':
        return []
    else:
        print(_type)
        return ''

def from_schema(ref):
    chunks = ref[2:].split('/')
    cur = data
    for c in chunks:
        cur = cur[c]
    res = {}
    for name, prop in cur['properties'].items():
        if '$ref' in prop:
            res[name] = from_schema(prop['$ref'])
        elif prop['type'] != 'array' or 'type' in prop['items']:
            res[name] = prop.get('default', default_value(prop['type']))
        else:
            res[name] = []
            res[name+'_type'] = from_schema(prop['items']['$ref'])
    return res

for path, pdata in data["paths"].items():
    for query_type, node in pdata.items():
        fields = {}
        fields['_header'] = []
        fields['_query'] = []
        fields['_body'] = []
        fields['_qtype'] = query_type
        if "parameters" in node:
            for par in node["parameters"]:
                if par['in'] == 'formData':
                    continue
                if par['in'] != 'body':
                    fields['_'+par['in']].append(par['name'])
                    fields[par['name']] = par.get('default', default_value(par['type']))
                else:
                    body = from_schema(par['schema']['$ref'])
                    for k, v in body.items():
                        fields[k] = v
                        if not k.endswith('_type'):
                            fields['_body'].append(k)

            key = path.replace('/','_')
            res[key] = fields
            res[key+'_'+fields['_qtype']] = fields
            print(key+'_'+fields['_qtype'])

with open("schema.json", "wt") as f:
    json.dump(res, f)

print('done')